package com.example.lab.AllTypeCalc.service;


import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;
import com.example.lab.AllTypeCalc.domain.CalculationInt;
import com.example.lab.AllTypeCalc.domain.ICalculation;

import java.util.Arrays;

@Service
public class CalcService {
    private final ApplicationContext applicationContext;
    private final Logger log = LoggerFactory.getLogger(CalculationInt.class);
    public CalcService(ApplicationContext applicationContext) {
        this.applicationContext = applicationContext;
    }

    public Object GetSum(Object firstInp, Object secondInp, String type) {
        final ICalculation calculator = (ICalculation) applicationContext.getBean(type);
        if(type.equals("str")){
            return calculator.GetSum(firstInp.toString(),secondInp.toString());
        }
        if(type.equals("int")) {
            return calculator.GetSum(Integer.parseInt(firstInp.toString()), Integer.parseInt(secondInp.toString()) );
        }
        if(type.equals("arr")){
            return calculator.GetSum(cleanToArr(firstInp) , cleanToArr(secondInp));
        }
        return "error";
    }
    public Object GetMinus(Object firstInp, Object secondInp, String type) {
        final ICalculation calculator = (ICalculation) applicationContext.getBean(type);
        if(type.equals("str")){
            return calculator.GetMinus(firstInp.toString(),secondInp.toString());
        }
        if (type.equals("int")){
            return calculator.GetMinus(Integer.parseInt(firstInp.toString()), Integer.parseInt(secondInp.toString()));
        }
        if(type.equals("arr")){
            return calculator.GetMinus(cleanToArr(firstInp) , cleanToArr(secondInp));
        }
        return "error";
    }
    public Object GetMult(Object firstInp, Object secondInp, String type) {
        final ICalculation calculator = (ICalculation) applicationContext.getBean(type);
        if(type.equals("str")){
            return calculator.GetMult(firstInp.toString(), secondInp.toString());
        }
        if (type.equals("int")){
            return calculator.GetMult(Integer.parseInt(firstInp.toString()),
                    Integer.parseInt(secondInp.toString()));
        }
        if (type.equals("arr")){
            return calculator.GetMult(cleanToArr(firstInp) , cleanToArr(secondInp));
        }
        return "error";
    }
    public Object GetDiv(Object firstInp, Object secondInp, String type) {
        final ICalculation calculator = (ICalculation) applicationContext.getBean(type);
        if (type.equals("str")){
            return  calculator.GetDiv(firstInp.toString(), secondInp.toString());
        }
        if (type.equals("int")){
            return calculator.GetDiv(
                    Integer.parseInt(firstInp.toString()),
                    Integer.parseInt(secondInp.toString()));
        }
        if(type.equals("arr")){
            return calculator.GetDiv(cleanToArr(firstInp) , cleanToArr(secondInp));
        }
        return "error";
    }

    public String[] cleanToArr(Object arr){
        return Arrays.stream(arr.toString()
                .split("[\\(\\)\\,\\.\\[\\] \\!\\?\\:\\;]"))
                .filter(e -> e.trim().length()>0)
                .toArray(String[]::new);
    }
}
