package com.example.lab.DataBase.Models;

import jakarta.persistence.*;

import java.util.*;

@Entity
public class Cart {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @OneToMany
    private List<CountProduct> countProducts;

    @OneToOne
    private Customer customer;

    public Cart(){}

    public Cart(Customer customer) {
        this.countProducts = new ArrayList<>();
        this.customer = customer;
    }

    @PreRemove
    public void deleteThis(){
        //deleteAllProducts();
        this.getCustomer().setCart(null);
    }


    public void addCountProduct(CountProduct countProduct){
        countProducts.add(countProduct);
        if (countProduct.getCart() != this) {
            countProduct.setCart(this);
        }
    }

    public void deleteCountProduct(CountProduct countProduct){
        countProducts.remove(countProduct);
        if (countProduct.getCart() == this) {
            countProduct.setCart(null);
        }
    }

    public Customer getCustomer() {
        return customer;
    }

    public void setCustomer(Customer customer) {
        this.customer = customer;
        if(customer.getCart()!=this){
            customer.setCart(this);
        }
    }

    public Long getId() {
        return id;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) return true;
        if (obj == null || getClass() != obj.getClass()) return false;
        Cart cart = (Cart) obj;
        return Objects.equals(id, cart.id);
    }

    @Override
    public int hashCode(){
        return Objects.hashCode(id);
    }
}
