package com.example.lab.DataBase.Models;
import jakarta.persistence.*;

import java.util.*;

@Entity
public class CountProduct {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @Column
    private Integer amount;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name="cart_fk")
    private Cart cart;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name="product_fk")
    private Product product;

    public CountProduct(){}

    public CountProduct(Cart cart, Product product) {
        this.cart = cart;
        this.product = product;
        this.amount = 0;
        this.cart.addCountProduct(this);
        this.product.addCountProduct(this);
    }

    public void setProduct(Product product) {
        this.product = product;
        if (product != null && !product.getCountProducts().contains(this)){
            product.addCountProduct(this);
        }
    }

    public Cart getCart() {
        return cart;
    }

    public void setCart(Cart cart) {
        this.cart = cart;
    }

    public Product getProduct() {
        return product;
    }

    public int getAmount() {
        return amount;
    }

    public void setAmount(int amount) {
        this.amount = amount;
    }

    public void incrementAmount(){
        this.amount++;
    }

    public void decrementAmount(){
        this.amount--;
    }

    @PreRemove
    public void deleteThis(){
        if(this.product !=null) this.product.deleteCountProduct(this);
        if(this.cart !=null) this.cart.deleteCountProduct(this);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) return true;
        if (obj == null || getClass() != obj.getClass()) return false;
        CountProduct countProducts = (CountProduct) obj;
        return Objects.equals(id, countProducts.id);
    }

    @Override
    public int hashCode(){
        return Objects.hashCode(id);
    }
}

