package com.example.lab.DataBase.Models;

import jakarta.persistence.*;
import java.util.*;

@Entity
public class ProductCategory {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    private String name;
    @OneToMany(fetch = FetchType.EAGER, mappedBy = "productCategory", cascade = CascadeType.ALL)
    private List<Product> products;

    public void AddProduct(Product product){
        this.products.add(product);
        if (product.getProductCategory() != this){
            product.setProductCategory(this);
        }
    }

    public void deleteProduct(Product product) {
        products.remove(product);
        if (product.getProductCategory() == this) {
            product.setProductCategory(null);
        }
    }
    public ProductCategory(){}

    public ProductCategory(String name){
        this.name = name;
        this.products = new ArrayList<Product>();
    }

    public Long getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<Product> getProducts() {
        return products;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) return true;
        if (obj == null || getClass() != obj.getClass()) return false;
        ProductCategory customer = (ProductCategory) obj;
        return Objects.equals(id, customer.id);
    }

    @Override
    public int hashCode(){
        return Objects.hashCode(id);
    }
}

