package com.example.lab;

import com.example.lab.AllTypeCalc.service.CalcService;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.NoSuchBeanDefinitionException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

@SpringBootTest
class LabApplicationTests {
	@Autowired
	CalcService calcService;

	@Test
	void testIntSum() {
		final Object result = calcService.GetSum(1, 2, "int");
		Assertions.assertEquals("3", result.toString());
	}

	@Test
	void testStringSum() {
		final Object result = calcService.GetSum("ab", "bc", "str");
		Assertions.assertEquals("abbc", result.toString());
	}

	@Test
	void testIntMinus() {
		final Object result = calcService.GetMinus(5, 4, "int");
		Assertions.assertEquals("1", result.toString());
	}

	@Test
	void testStringMinus() {
		final Object result = calcService.GetMinus("abc", "bc", "str");
		Assertions.assertEquals("a", result.toString());
	}

	@Test
	void testIntMult() {
		final Object result = calcService.GetMult(4, 4, "int");
		Assertions.assertEquals("16", result.toString());
	}

	@Test
	void testStringMult() {
		final Object result = calcService.GetMult("ab", "bc", "str");
		Assertions.assertEquals("abab", result.toString());
	}

	@Test
	void testIntDiv() {
		final Object result = calcService.GetDiv(12, 6, "int");
		Assertions.assertEquals("2", result.toString());
	}

	@Test
	void testStringDiv() {
		final Object result = calcService.GetDiv("ab", "bc", "str");
		Assertions.assertEquals("1.0", result.toString());
	}

	@Test
	void testCalculatorErrorWired() {
		Assertions.assertThrows(NoSuchBeanDefinitionException.class, () -> calcService.GetSum("1", "1", "integer"));
	}
}
